;------------
; imports
;------------
from_dll kernel32.dll

	import	ExitProcess 		[1] win64
	import	GetModuleHandleA 	[1] win64
	import	GetLastError	 	; [0] win64

from_dll user32.dll

	import	MessageBoxA
	import	DefWindowProcA
	import	CreateWindowExA
	import	ShowWindow
	import	UpdateWindow
	;import	DestroyWindow
	import	RegisterClassA

	import	GetMessageA
	import	TranslateMessage
	import	DispatchMessageA
	import	PostQuitMessage 	[1] win64
	import	LoadCursorA
	import	LoadIconA
	import	BeginPaint 		[2] win64
	import	EndPaint 		[2] win64

from_dll gdi32.dll	
	import	TextOutA 		[5] win64



;-----------------------
; win 64 structures
;-----------------------
CS_VREDRAW			equ	1h
CS_HREDRAW			equ	2h

STRUC WNDCLASS
	style			dq	?
	wnd_proc_ptr		dq	?
	cls_extra		dd	?
	wnd_extra		dd	?
	instance_handle		dq	?
	icon_handle		dq	?
	cursor_handle		dq	?
	back_brush_handle	dq	?
	menu_name_ptr		dq	?
	class_name_ptr		dq	?
ENDS


STRUC MSG
	hwnd			dq	?
	message			dq	?
	wParam			dq	?
	lParam			dq	?

	time			dd	?

	pt_x			dd	?
	pt_y			dd	?

	;padding		dd	?
ENDS

struc RECT
	left		dd	?
	top		dd 	?
	right		dd 	?
	bottom		dd 	?
ends


STRUC PAINTSTRUCT
	hdc			dq	?
	fErase			dd	?

	rect			rs	RECT,1

  	fRestore		dd	?
	fIncUpdate		dd	?
	rgbReserved		rb	32

ENDS


;----------------------
; Colors
;----------------------
COLOR_MENU			equ	4
COLOR_WINDOW			equ	5
COLOR_BTNFACE			equ	15
COLOR_BTNSHADOW			equ	16
COLOR_GRAYTEXT			equ	17
COLOR_BTNTEXT			equ	18
COLOR_3DDKSHADOW		equ	21

;----------------------
; Cursors
;----------------------
IDC_ARROW			equ	32512
IDC_IBEAM			equ	32513
IDC_WAIT			equ	32514
IDC_CROSS			equ	32515
IDC_UPARROW			equ	32516
IDC_SIZE			equ	32640
IDC_ICON			equ	32641
IDC_SIZENWSE			equ	32642
IDC_SIZENESW			equ	32643
IDC_SIZEWE			equ	32644
IDC_SIZENS			equ	32645
IDC_SIZEALL			equ	32646
IDC_NO				equ	32648
IDC_HAND			equ	32649
IDC_APPSTARTING			equ	32650
IDC_HELP			equ	32651

;-------------------------
; Icons
;-------------------------
IDI_APPLICATION			equ	32512
IDI_HAND			equ	32513
IDI_QUESTION			equ	32514
IDI_EXCLAMATION			equ	32515
IDI_ASTERISK			equ	32516
IDI_WINLOGO			equ	32517


SW_SHOW				equ 	5

;----------------------
; Messages
;----------------------
WM_CREATE			equ	1h
WM_DESTROY			equ	2h
WM_MOVE				equ	3h
WM_SIZE				equ	5h
WM_ACTIVATE			equ	6h
WM_SETFOCUS			equ	7h

WM_PAINT			equ	0Fh

;----------------------
; Window Styles
;----------------------
WS_OVERLAPPED			equ	0000_0000h

WS_MAXIMIZEBOX			equ	0001_0000h
WS_MINIMIZEBOX			equ	0002_0000h
WS_THICKFRAME			equ	0004_0000h
WS_SYSMENU			equ	0008_0000h

WS_DLGFRAME			equ	0040_0000h

WS_CAPTION			equ	00C0_0000h
WS_POPUP			equ	8000_0000h

WS_VISIBLE			equ	1000_0000h

;---------------------------------
; Message box types
;---------------------------------
MB_OK				equ	0h
MB_OKCANCEL			equ	1h
MB_ABORTRETRYIGNORE		equ	2h
MB_YESNOCANCEL			equ	3h
MB_YESNO			equ	4h
MB_RETRYCANCEL			equ	5h
MB_ICONHAND			equ	10h
MB_ICONQUESTION			equ	20h
MB_ICONEXCLAMATION		equ	30h
MB_ICONASTERISK			equ	40h
MB_USERICON			equ	80h
